﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WinGraphsNet
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private void btnCalculate_Click(object sender, EventArgs e)
        {
            // Считываем введённые значения
            float MinX, MaxX, Step, A;
            try
            {
                MinX = float.Parse(tbMinX.Text);
                MaxX = float.Parse(tbMaxX.Text);
                Step = float.Parse(tbStep.Text);
                A = float.Parse(tbA.Text);
            } catch (FormatException)
            {
                MessageBox.Show("Формат введённых чисел неверный");
                return;
            }

            if (MaxX < MinX || MaxX == MinX)
            {
                MessageBox.Show("MaxX не может быть меньше или равен MinX");
                return;
            }

            if (Step == 0)
            {
                MessageBox.Show("Шаг не может быть равен нулю!");
                return;
            }

            // Подготовка к обновлению графика
            int PointCount = (int)Math.Ceiling((MaxX - MinX) / Step) + 1; // Количество точек
            var PointsX = new float[PointCount]; // Координата X
            var PointsY = new float[PointCount]; // Координата Y

            // Вычисление значений графика
            for (int i = 0; i < PointCount; i++)
            {
                PointsX[i] = MinX + Step * i; // Вычисление X
                PointsY[i] = (float)(9 * (Math.Pow(PointsX[i], 3) + Math.Pow(A, 3) * Math.Tan(PointsX[i])));
            }

            // Настройка графика
            chrtMain.ChartAreas[0].AxisX.Minimum = MinX;
            chrtMain.ChartAreas[0].AxisX.Maximum = MaxX;
            chrtMain.ChartAreas[0].AxisX.MajorGrid.Interval = Step;
            chrtMain.Series[0].Points.DataBindXY(PointsX, PointsY);
        }
    }
}
